
<template>
    <div class="cg-pagination grey">
        <ul class="cg-pagination-alignment d-flex justify-content-end">
          <li>
              <a class="pagination-previous" @click.prevent="changePage(pagination.current_page - 1)" v-if="pagination.current_page > 1" :disabled="pagination.current_page <= 1"> < </a>
             </li>
            <li v-for="page in pages" :class="isCurrentPage(page) ? 'cg-active-page' : ''">
                <a class="pagination-link" :class="isCurrentPage(page) ? 'cg-active-page' : ''" @click.prevent="changePage(page)">{{ page }}</a>
            </li>
          <li>
              <a class="pagination-next" @click.prevent="changePage(pagination.current_page + 1)" v-if="pagination.current_page < pagination.last_page" :disabled="pagination.current_page >= pagination.last_page"> > </a>
          </li>

        </ul>
    </div>

</template>

<script>
    export default {
        props: ['pagination', 'offset'],
        methods: {
            isCurrentPage(page) {
                return this.pagination.current_page === page;
            },
            changePage(page) {
                if (page > this.pagination.last_page) {
                    page = this.pagination.last_page;
                }
                this.pagination.current_page = page;
                this.$emit('paginate');
            }
        },
        computed: {
            pages() {
                let pages = [];
                let from = this.pagination.current_page - Math.floor(this.offset / 2);
                if (from < 1) {
                    from = 1;
                }
                let to = from + this.offset - 1;
                if (to > this.pagination.last_page) {
                    to = this.pagination.last_page;
                }
                while (from <= to) {
                    pages.push(from);
                    from++;
                }
                return pages;
            }
        }
    }
</script>
